﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Kresleni
{
    public partial class Window : Form
    {
        public Window()
        {
            InitializeComponent();
            pictureBox_SizeChanged (null, null);
        }

        private void pictureBox_SizeChanged(object sender, EventArgs e)
        {
            int w = pictureBox.Width;
            int h = pictureBox.Height;

            Bitmap old = null;
            if (pictureBox.Image != null)
            {
                old = new Bitmap (pictureBox.Image);
                if (pictureBox.Image.Width > w)  w = pictureBox.Image.Width;
                if (pictureBox.Image.Height > h) h = pictureBox.Image.Height;
            }

            pictureBox.Image = new Bitmap (w, h);
            Graphics g = Graphics.FromImage (pictureBox.Image);
            Brush b = new SolidBrush (Color.White);
            g.FillRectangle (b, 0, 0, w, h);

            if (old != null)
               g.DrawImage (old, 0, 0);
        }


        private int X0, Y0;
        private bool down = false;
        private Bitmap save = null;

        private void pictureBox_MouseDown(object sender, MouseEventArgs e)
        {
            X0 = e.X;
            Y0 = e.Y;
            down = true;
            save = new Bitmap (pictureBox.Image);
        }
        private void pictureBox_MouseMove(object sender, MouseEventArgs e)
        {
            if (down)
            {
                Graphics g = Graphics.FromImage(pictureBox.Image);
                g.DrawImage (save, 0, 0);
                Pen p = new Pen(Color.Green);
                p.Width = 1;
                g.DrawLine(p, X0, Y0, e.X, e.Y);
                pictureBox.Invalidate();
            }
        }
        private void pictureBox_MouseUp(object sender, MouseEventArgs e)
        {
            if (down)
            {
                down = false;
                Graphics g = Graphics.FromImage(pictureBox.Image);
                g.DrawImage(save, 0, 0);
                Pen p = new Pen(Color.Red);
                p.Width = 7;
                // p.StartCap = System.Drawing.Drawing2D.LineCap.Round;
                // p.EndCap = System.Drawing.Drawing2D.LineCap.Round;
                g.DrawLine(p, X0, Y0, e.X, e.Y);
                pictureBox.Invalidate();
            }
        }

        private void quitMenu_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void pictureBox_Click(object sender, EventArgs e)
        {

        }

        private void openMenu_Click(object sender, EventArgs e)
        {
            if (openDialog.ShowDialog() == DialogResult.OK)
            {
                pictureBox.Image = new Bitmap (openDialog.FileName);
            }

        }


    }
}
